<?php
/**
 * (c) 2004-2006 Linbox / Free&ALter Soft, http://linbox.com
 *
 * $Id$
 *
 * This file is part of LMC.
 *
 * LMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * LMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with LMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
?>
<?

$title = "Droits d'impression sur l'imprimante";

$path = array(array("name" => "Accueil",
                    "link" => "main.php"),
              array("name" => "Imprimantes",
                    "link" => "main.php?module=printers&submod=printers&action=index"),
              array("name" => "Droits par imprimante",
                    "link" => "main.php?module=printers&submod=printers&action=byprinter"),
              array("name" => "$title"));

require("localSidebar.php");
require("graph/navbar.inc.php");
require("modules/printing/includes/xmlrpc.php");

/* To get user and group list */
require("modules/base/includes/groups.inc.php");
require("modules/base/includes/users.inc.php");


$printer = $_GET["printer"];

print "<h2>$title <b>$printer</b></h2>";
print '<div class="fixheight"></div>';

$p = new PageGenerator();
$p->setSideMenu($sidemenu);
$p->displaySideMenu();

if (!strlen($printer)) {
    $error = "Le nom de l'imprimante est invalide.";
    print "<div id=\"errorCode\">$error</div>";
    exit;
}

if (isset($_POST["badduser_x"])) {
    foreach($_POST["users"] as $idx => $user)
        setUserPrinterAccess($user, $printer, True);
}

if (isset($_POST["bdeluser_x"])) {
    foreach($_POST["ausers"] as $idx => $user)
        setUserPrinterAccess($user, $printer, False);
}

if (isset($_POST["baddgroup_x"])) {
    foreach($_POST["groups"] as $idx => $group) {
        setGroupPrintServiceAccess($group, True);
        setGroupPrinterAccess($group, $printer, True);
    }
}

if (isset($_POST["bdelgroup_x"])) {
    foreach($_POST["agroups"] as $idx => $group) {
        setGroupPrintServiceAllRights($group, False);
        setGroupPrinterAccess($group, $printer, False);
    }
}

/* List of users and groups */
$users = get_users($error);
$groups = get_groups($error);


//fix changement of accessor for group
$tmp = array();
foreach ($groups as $group) {
    $tmp[] = $group[0];
}

$groups = $tmp;
//end fix changement

/* List of authorized users and groups */
$ausers = getUsersAccessForPrinter($printer);
$agroups = getGroupsAccessForPrinter($printer);

$arg = getGroupsServiceAllRights();
$psag = getGroupsServiceAllowed();

foreach($arg as $idx => $group) {
    $ind = array_search($group, $groups);
    if ($ind >= 0) {
        unset($groups[$ind]);
        array_push($agroups, $group);
    }
}

?>

<style type="text/css">
<!--

#fullaccess div.list
{
        float: left;
}

select.list
{
        width: 250px;
}

-->
</style>

<form method="POST">

<!-- First form: users form -->

<div style="display:none">
<table style="border: none;" cellspacing="0">
<tr><td style="border: none;">
  <div class="list">
        <h3><?= _T("All groups"); ?></h3>
    <select multiple size="10" class="list" name="users[]">

<?php
foreach ($users as $idx => $user)
{
    $idx = array_search($user, $ausers);
    if ($idx === false) echo "<option value=\"".$user."\">".$user."</option>\n";
}
?>
    </select>

    <br>

  </div>
  </td><td style="border: none;">
  <div>
  <input type="image" name="bdeluser" style="padding: 5px;" src="img/common/icn_arrowleft.gif" value="<--" /><br/>
  <input type="image" name="badduser" style="padding: 5px;" src="img/common/icn_arrowright.gif" value = "-->"/>
  </div>
  </td><td style="border: none;">

  <div class="list" style="padding-left: 80px;">
      <h3><?= _T("Authorized users"); ?></h3>
    <select multiple size="10" class="list" name="ausers[]">
<?php
foreach ($ausers as $idx => $user)
{
    echo "<option value=\"".$user."\">".$user."</option>\n";
}
?>
    </select>

    <br>

  </div>
  <div class="clearer"></div>
  </td></tr>
</table>
</div>

<!-- second form: groups form -->

<div>
<table style="border: none;" cellspacing="0">
<tr><td style="border: none;">
  <div class="list">
        <h3><?= _T("All groups"); ?></h3>
    <select multiple size="15" class="list" name="groups[]">

<?php
foreach ($groups as $idx => $group)
{
    $idx = array_search($group, $agroups);
    if ($idx === false) {
        $idx = array_search($group, $psag);
        if ($idx === false) $extra = _T(" (no right)");
        else $extra = "";
        echo "<option value=\"".$group."\">".$group.$extra."</option>\n";
    }
}
?>
    </select>

    <br>

  </div>
  </td><td style="border: none;">
  <div>
  <input type="image" name="bdelgroup" style="padding: 5px;" src="img/common/icn_arrowleft.gif" value="<--" /><br/>
  <input type="image" name="baddgroup" style="padding: 5px;" src="img/common/icn_arrowright.gif" value = "-->"/>
  </div>
  </td><td style="border: none;">

  <div class="list" style="padding-left: 80px;">
      <h3><?= _T("Authorized groups"); ?></h3>
    <select multiple size="15" class="list" name="agroups[]">
<?php
foreach ($agroups as $idx => $group)
{
    if (!(array_search($group, $arg) === False)) $extra = _T(" (all rights)");
    else $extra = "";
    echo "<option value=\"".$group."\">".$group.$extra."</option>\n";
}
?>
    </select>

    <br>

  </div>
  <div class="clearer"></div>
  </td></tr>
</table>
</div>

</form>

